Attribute VB_Name = "modBuildClassProperty"
' modBuildClassProperty
' 1998/04/17 Copyright 1998, Larry Rebich
    
    Option Explicit
    DefLng A-Z
    
    Public mcolAsTypes      As Collection    'As Type' Collection
    
    ' Registry Constants
    Public Const gcsCompanyLong As String = "The Bridge, Inc."
    Const mcsCompany        As String = "The Bridge\"
    Const mcsSoftware       As String = "Software\"
    Const mcsProductName    As String = "TB Build Class Property"
    Const mcsComma          As String = ","
    Const csState           As String = "State"         'Normal, Minimized, Maximized
    Const csLocation        As String = "Location"      'Left, Top, Width, Height
    Public glNewTopTextHeight   As Long                 'splitter
    '
    
Public Function SaveGetDeclarationsFieldPrefixAndTab(sPrefix As String, iPrefixTab As Integer, bSave As Boolean) As Boolean
' Save or Get Field Prefix and Tab desired to/from Registry
    Const csDec = "Declarations Field "
    Const csPrefix = "Prefix"
    Const csTab = "Tab"
    Dim sKey    As String
    Dim sValue  As String
    Dim sValue2 As String
    
    sKey = mcsSoftware & mcsCompany & mcsProductName
    If bSave Then
        RegWrite sKey, csDec & csPrefix, sPrefix
        RegWrite sKey, csDec & csTab, CStr(iPrefixTab)
    Else
        sValue = RegRead(sKey, csDec & csPrefix)
        sValue2 = RegRead(sKey, csDec & csTab)
        If sValue <> "" Then
            sPrefix = sValue
        Else
            sPrefix = "m"               'default prefix
        End If
        If IsNumeric(sValue2) Then
            iPrefixTab = Val(sValue2)
            If iPrefixTab = vbChecked Or iPrefixTab = vbUnchecked Then
            Else
                iPrefixTab = vbUnchecked
            End If
        Else
            iPrefixTab = vbUnchecked
        End If
        SaveGetDeclarationsFieldPrefixAndTab = True
    End If
End Function

Public Function BuildAsTypesCollection() As Boolean
' Build the AsTypes Collection
    Dim bValue      As Boolean
    Dim iNumber     As Integer
    Dim sAsType     As String
    Dim sAsTypePrefix As String

    Set mcolAsTypes = New Collection
    
    If SaveGetAsTypes(1, sAsType, sAsTypePrefix, False) Then        'are there any?
        bValue = True
        While bValue
            iNumber = iNumber + 1
            bValue = SaveGetAsTypes(iNumber, sAsType, sAsTypePrefix, False)
            If bValue Then
                AddType sAsType, sAsTypePrefix, iNumber
            End If
        Wend
    Else
        AddType "Boolean", "b", 1         'default types
        AddType "Byte", "c", 2
        AddType "Date", "d", 3
        AddType "Double", "f", 4
        AddType "Integer", "i", 5
        AddType "Long", "l", 6
        AddType "Single", "r", 7
        AddType "String", "s", 8
        AddType "Variant", "vnt", 9
        SaveAsTypesCollection
    End If
    BuildAsTypesCollection = True
End Function

Private Sub AddType(sAsType As String, sAsTypePrefix As String, iIndex As Integer)
' Add an 'As Type' object to a collection.
    Dim objAsType As clsAsType
    Set objAsType = New clsAsType
    With objAsType
        .sAsType = sAsType
        .sAsTypePrefix = sAsTypePrefix
        .sKey = CStr(iIndex)
        mcolAsTypes.Add objAsType, .sKey
    End With
    Set objAsType = Nothing
End Sub

Public Function SaveAsTypesCollection() As Boolean
' Save all 'As Type' items from the collection into the registry
    Dim objAsType As clsAsType
    Dim iNumber As Integer
    
    DeleteAllAsTypeFromRegistry
    
    For Each objAsType In mcolAsTypes
        With objAsType
            If Not .bDeleted Then
                iNumber = iNumber + 1
                SaveGetAsTypes iNumber, .sAsType, .sAsTypePrefix, True
            End If
        End With
    Next
    Set objAsType = Nothing
End Function

Private Sub DeleteAllAsTypeFromRegistry()
' Delete 1 to 99 As Types, hope this is enough
    Dim iNumber As Integer
    For iNumber = 1 To 99
        SaveGetAsTypes iNumber, "", "", True
    Next
End Sub

Private Function SaveGetAsTypes(iNumber As Integer, sAsType As String, sAsTypePrefix As String, bSave As Boolean) As Boolean
' Save or Get 'As Types' from the registry
    Dim sKey    As String
    Dim sNumber As String
    Const csAsType = "As Type"
    Const csPrefix = " Prefix"
    sKey = mcsSoftware & mcsCompany & mcsProductName
    sNumber = " " & Format$(iNumber, "00")
    If bSave Then
        RegWrite sKey, csAsType & sNumber, sAsType
        RegWrite sKey, csAsType & sNumber & csPrefix, sAsTypePrefix
    Else
        sAsType = RegRead(sKey, csAsType & sNumber)
        sAsTypePrefix = RegRead(sKey, csAsType & sNumber & csPrefix)
        If sAsType <> "" And sAsTypePrefix <> "" Then
            SaveGetAsTypes = True
        End If
    End If
End Function

Public Sub LoadListBox(frm As Form, lst As ListBox, bAll As Boolean)
' Load lst with 'As Types'. Don't load deleted ones unless bAll = True.
    Dim objAsType As clsAsType
    Dim bAddIt    As Boolean
    
    lst.Clear
    For Each objAsType In mcolAsTypes
        With objAsType
            bAddIt = True
            If .bDeleted Then
                bAddIt = False
            End If
            If bAll Then
                bAddIt = True
            End If
            If bAddIt Then
                lst.AddItem BuildListItem(objAsType)
                lst.ItemData(lst.NewIndex) = Val(.sKey)
            End If
        End With
    Next
    Set objAsType = Nothing
End Sub

Private Function BuildListItem(objAsType As clsAsType) As String
' Build the name of the 'As Type' shown in the ListBox
    With objAsType
        BuildListItem = .sAsType & vbTab & " [" & .sAsTypePrefix & "]"
    End With
End Function

Public Sub SetPropertyPrefix(frm As Form, lst As ListBox, txt As TextBox)
' The user has clicked the list box, change the prefix. For example show 'b' for 'Boolean'
    Dim iListIndex As Integer
    Dim lItemData  As Long
    Dim objAsType As clsAsType
    
    iListIndex = lst.ListIndex
    lItemData = lst.ItemData(iListIndex)

    Set objAsType = mcolAsTypes(CStr(lItemData))
    txt.Text = objAsType.sAsTypePrefix
    Set objAsType = Nothing
End Sub

Public Function GetTypeFromListBox(lst As ListBox) As String
' The user has clicked the frmEditType list box. Return the 'As Type'.
    Dim iListIndex  As Integer
    Dim lItemData   As Long
    Dim objAsType   As clsAsType
    
    iListIndex = lst.ListIndex
    lItemData = lst.ItemData(iListIndex)
    Set objAsType = mcolAsTypes(CStr(lItemData))
    GetTypeFromListBox = objAsType.sAsType
    Set objAsType = Nothing
End Function

Public Sub DoAddAsType(frm As Form, lst As ListBox, sAsTypePrefix As String, sAsType As String)
' Adding a new 'As Type' from frmEditType
    Dim objAsType As clsAsType
    Dim i As Integer
    Dim lItemData As Long
    
    Set objAsType = New clsAsType
    With objAsType
        .sAsType = sAsType
        .sAsTypePrefix = sAsTypePrefix
        .sKey = CStr(mcolAsTypes.Count + 1)
        lst.AddItem BuildListItem(objAsType)
        lItemData = Val(.sKey)
        lst.ItemData(lst.NewIndex) = lItemData
        mcolAsTypes.Add objAsType, .sKey
    End With
    For i = 0 To lst.ListCount - 1              'set list box to newly added item
        If lst.ItemData(i) = lItemData Then
            lst.Selected(i) = True
        End If
    Next
    Set objAsType = Nothing
End Sub

Public Sub DoDeleteAsType(frm As Form, lst As ListBox)
' Delete an 'As Type' from frmEditType
    Dim objAsType   As clsAsType
    Dim i           As Integer
    Dim lItemData   As Long
    Dim iListIndex  As Integer
    
    iListIndex = lst.ListIndex
    lItemData = lst.ItemData(iListIndex)
    Set objAsType = mcolAsTypes(CStr(lItemData))
    objAsType.bDeleted = True
    LoadListBox frm, lst, False
    If lst.ListCount < iListIndex - 2 Then
        lst.ListIndex = iListIndex
    ElseIf lst.ListCount > 0 Then
        lst.ListIndex = 0
    End If
End Sub

Public Sub DoUpdateAsType(frm As Form, lst As ListBox, sAsTypePrefix As String, sAsType As String)
' The user wants to change an 'As Type'
    Dim objAsType As clsAsType
    Dim i As Integer
    Dim lItemData As Long
    Dim iListIndex  As Integer
    
    iListIndex = lst.ListIndex
    lItemData = lst.ItemData(iListIndex)
    Set objAsType = mcolAsTypes(CStr(lItemData))
    With objAsType
        .sAsType = sAsType
        .sAsTypePrefix = sAsTypePrefix
    End With
    LoadListBox frm, lst, False
    For i = 0 To lst.ListCount - 1              'set list box to changed item
        If lst.ItemData(i) = lItemData Then
            lst.Selected(i) = True
        End If
    Next
    Set objAsType = Nothing
End Sub

Public Sub DoEditType(frm As Form, lst As ListBox)
' Load frmEditType and allow user to edit the 'As Types'
    frmEditType.Show vbModal            'show the form modally
    DoEvents                            'let screen repaint
    If frmEditType.gbOKPressed Then     'if user pressed OK then,
        SaveAsTypesCollection               'save the collection
        Set mcolAsTypes = Nothing           'clear the collection
        BuildAsTypesCollection              'reload the collection
        LoadListBox frm, lst, True          'reload the 'As Type' list box
        If lst.ListCount > 0 Then       'if any then select the first one
            lst.ListIndex = 0
            lst.Selected(0) = True
        End If
    End If
    Unload frmEditType                  'dump frmEditType
    Set frmEditType = Nothing           'set it to nothing
End Sub

Public Function NewAsType(sAsType As String) As Boolean
' Return True if sAsType not in the collection
    Dim objAsType   As clsAsType
    
    For Each objAsType In mcolAsTypes           'look through the collection
        With objAsType
            If Not .bDeleted Then
                If LCase$(.sAsType) = sAsType Then  'exists?
                    Exit Function                   'yes, out you go
                End If
            End If
        End With
    Next
    Set objAsType = Nothing
    NewAsType = True     'is new
End Function

Public Function NotTooSmall(lValue As Long, lMin As Long) As Long
' 1998/01/21 Can't Be Too Small
    If lValue < lMin Then
        NotTooSmall = lMin
    Else
        NotTooSmall = lValue
    End If
End Function

Public Function GetFormInformation(frm As Form, iState As Integer, lLeft As Long, lTop As Long, lWidth As Long, lHeight As Long) As Integer
' Return True if this is successful, otherwise false
' Return the values found in the registry
    Dim ll As Long, lT As Long, lW As Long, lH As Long
    Dim sState      As String
    Dim sLocation   As String
    Dim sKey        As String
    
    sKey = SetKeyForm(frm)                              'build the key
    sLocation = RegRead(sKey, csLocation)               'read the setting
    If sLocation <> "" Then                             'none found
        If ConvertLocationToIntegers(sLocation, ll, lT, lW, lH) Then
            lLeft = ll
            lTop = lT
            lWidth = lW
            lHeight = lH
            GetFormInformation = True
        End If
    End If
    sState = RegRead(sKey, csState)
    iState = ConvertStateToInteger(sState)
End Function

Public Function SaveFormInformation(frm As Form) As Integer
' Save information about a form in the registry
    Dim iState      As Integer
    Dim sFormName   As String
    Dim sKey        As String
    With frm
        sFormName = .Name
        iState = .WindowState
    End With
    sKey = SetKeyForm(frm)
    RegWrite sKey, csState, CStr(ConvertStateToString(iState))
    If iState = vbNormal Then   'don't change the location if not normal state
        RegWrite sKey, csLocation, CStr(ConvertLocationToString(frm))
    End If
    SaveFormInformation = True
End Function

Private Function SetKeyCompany() As String
    SetKeyCompany = mcsSoftware & mcsCompany
End Function
Private Function SetKeyProduct() As String
    SetKeyProduct = SetKeyCompany & mcsProductName
End Function

Private Function SetKeyForm(frm As Form) As String
    Dim sTemp As String
    sTemp = SetKeyProduct & "\" & frm.Name
    SetKeyForm = sTemp
End Function

Private Function ConvertLocationToString(frm As Form) As String
' Return the forms location in a string, for example: "20,40,4600,3200" for left,top,width,height
    Dim sTemp As String
    With frm
        sTemp = CStr(.Left) & mcsComma
        sTemp = sTemp & CStr(.Top) & mcsComma
        sTemp = sTemp & CStr(.Width) & mcsComma
        sTemp = sTemp & CStr(.Height)
    End With
    ConvertLocationToString = sTemp
End Function

Private Function ConvertLocationToIntegers(sTheString As String, lLeft As Long, lTop As Long, lWidth As Long, lHeight As Long) As Integer
' Return the four numbers found in a string variable as long integers, for example:
' input:  sTheString = "20,40,4600,3200"
' output: lLeft = 20
'         lTop = 40
'         lWidth = 4600
'         lHeight = 3200
' Return True if successful, False if can't process or all values are zero
    Dim i As Integer                'place counter
    Dim l As Long                   'temp long integer
    Dim iCnt As Integer             'counter
    Dim sTemp As String             'temporary string
    sTemp = "@" & sTheString & "@"  '95/08/30 Make sure we have 3 commas
    ' check, make sure we have 3 commas
    While InStr(sTemp, mcsComma)
        iCnt = iCnt + 1
        i = InStr(sTemp, mcsComma)
        sTemp = Mid$(sTemp, i + 1)
    Wend
    If iCnt <> 3 Then Exit Function 'error, none so exit
    
    iCnt = 0
    sTemp = sTheString & mcsComma & " "  'add an extra comma and space
    On Error GoTo ConvertLocationToIntegersError    'bad string or something
    While InStr(sTemp, mcsComma)
        i = InStr(sTemp, mcsComma)       'where is it
        l = CLng(Mid$(sTemp, 1, i - 1)) 'convert it to an integer
        iCnt = iCnt + 1
        Select Case iCnt
            Case 1
                lLeft = l
            Case 2
                lTop = l
            Case 3
                lWidth = l
            Case 4
                lHeight = l
            Case Else
                Exit Function       'should not
        End Select
        sTemp = Mid$(sTemp, i + 1)
    Wend
    If iCnt = 4 Then
        If lLeft + lTop + lWidth + lHeight > 0 Then
            ConvertLocationToIntegers = True    'success
        End If
    End If
    Exit Function
ConvertLocationToIntegersError:                 'bad, no real harm
End Function

Public Function ConvertStateToString(iState As Integer) As String
' return the WindowState as as string
    Select Case iState
        Case vbNormal
            ConvertStateToString = "Normal"
        Case vbMinimized
            ConvertStateToString = "Minimized"
        Case vbMaximized
            ConvertStateToString = "Maximized"
    End Select
End Function

Private Function ConvertStateToInteger(sState As String) As Integer
' return the WindowState as an integer
' 1995/08/30 Bug - select statement used sState not s - Larry
    Dim iTemp As Integer        'temp integer
    Dim sTemp As String         'temp string
    sTemp = LCase$(sState)      'convert to all lower
    Select Case sTemp           'what state - 95/08/30 Use s not sState - Larry
        Case "normal"
            iTemp = vbNormal
        Case "minimized"
            iTemp = vbMinimized
        Case "maximized"
            iTemp = vbMaximized
    End Select
    ConvertStateToInteger = iTemp   'return the value
End Function

Public Sub DoHelpInfo(frm As Form)
' User Word to display a readme file.
    Const csReadMe  As String = "Readme.doc"
    Dim obj         As Object
    Dim sAppPath    As String
    
    On Error GoTo DoHelpInfoEH
    sAppPath = App.Path
    If Right$(sAppPath, 1) <> "\" Then
        sAppPath = sAppPath & "\"
    End If
    Set obj = GetObject("", "Word.Application")
    With obj
        .Application.Visible = True         'make it visible
        .Application.Activate               'set it active
        .Documents.Open sAppPath & csReadMe, True, True    'convert and read-only
    End With
    Exit Sub
DoHelpInfoEH:
    MsgBox "Unable to use MSWord to open " & sAppPath & csReadMe & ".", vbExclamation, "Err: " & Err.Number & ", Description: " & Err.Description
End Sub
Public Sub DoHelpInfoEditType(frm As Form)
    DoHelpInfo frm          'same help
End Sub
Public Sub DoHelpAbout(frm As Form)
' Create About Information
    Dim sMsg As String
    Dim sYr  As String
    Const csBaseYear = "1998"   'first year written
    
    sYr = Format$(Date, "yyyy")
    If sYr <> csBaseYear Then
        sMsg = sMsg & "Copyright  " & csBaseYear & "-" & sYr
    Else
        sMsg = sMsg & "Copyright  " & sYr
    End If
    sMsg = sMsg & vbCrLf & vbCrLf
    sMsg = sMsg & vbTab & "Larry Rebich" & vbCrLf
    sMsg = sMsg & vbTab & gcsCompanyLong & vbCrLf
    sMsg = sMsg & vbTab & "913 Hacienda Way" & vbCrLf
    sMsg = sMsg & vbTab & "Millbrae, CA 94030" & vbCrLf & vbCrLf
    sMsg = sMsg & "Phone:" & vbTab & "650-737-0870" & vbCrLf
    sMsg = sMsg & "Fax:" & vbTab & "650-737-0871" & vbCrLf
    sMsg = sMsg & "e-Mail:" & vbTab & "lrebich@earthlink.net             "
    MsgBox sMsg, vbInformation, " " & App.ProductName & ", " & AppVersion
End Sub

Private Function AppVersion() As String
'Build version info
    Dim sTemp As String
    
    sTemp = App.Major & "." & Format$(App.Minor, "00") & "." & Format$(App.Revision, "00")
    AppVersion = "Version " & sTemp
End Function

Public Function SaveGetSplitLocationFromRegistry(frm As Form, lValue As Variant, bSave As Boolean) As Long
' Save or Get the Split location from the registry for frm.
    Dim sKey    As String
    Dim sValue  As String
    Const csName = "Splitter"
    sKey = SetKeyForm(frm)
    If bSave Then
        RegWrite sKey, csName, CStr(lValue)
    Else
        sValue = RegRead(sKey, csName)
        If sValue <> "" Then
            SaveGetSplitLocationFromRegistry = Val(sValue)
        End If
    End If
End Function
Public Sub GetLastAsType(frm As Form, lst As ListBox)
' Get the last 'As Type' and select it
    Dim sAsType As String
    If SaveGetLastSelectedAsType(sAsType, False) Then
        SetListIndexUsingAsType lst, sAsType
    Else
        If lst.ListCount > 0 Then
            lst.ListIndex = 0
        End If
    End If
End Sub

Private Sub SetListIndexUsingAsType(lst As ListBox, sAsType As String)
' Set the 'As Type' selected
    Dim i As Integer
    For i = 0 To lst.ListCount - 1
        If InStr(lst.List(i), sAsType) > 0 Then
            lst.Selected(i) = True
            Exit Sub
        End If
    Next
End Sub

Public Sub SaveLastAsType(frm As Form, lst As ListBox)
    Dim sAsType As String
    sAsType = GetTypeFromListBox(lst)
    SaveGetLastSelectedAsType sAsType, True
End Sub

Public Function SaveGetLastSelectedAsType(sAsType As String, bSave As Boolean) As Boolean
' Save or Get the last selected 'As Type'
    Dim sKey    As String
    Const csName = "Last As Type"
    
    sKey = SetKeyProduct()
    If bSave Then
        RegWrite sKey, csName, sAsType
    Else
        sAsType = RegRead(sKey, csName)
        If sAsType <> "" Then
            SaveGetLastSelectedAsType = True
        End If
    End If
End Function









